SystemOrganization addCategory: #'Magritte-Chronos-Description'!
SystemOrganization addCategory: #'Magritte-Chronos-Seaside'!
SystemOrganization addCategory: #'Magritte-Chronos-Tests'!

!MAVisitor methodsFor: '*Magritte-Chronos' stamp: 'pmm 10/20/2006 21:42'!
visitChronosDescription: aChronosDescription
	self visitMagnitudeDescription: aChronosDescription! !

!MAVisitor methodsFor: '*Magritte-Chronos' stamp: 'pmm 10/20/2006 21:43'!
visitScientificDurationDescription: aScientificDurationDescription
	self visitChronosDescription: aScientificDurationDescription! !

!MAVisitor methodsFor: '*Magritte-Chronos' stamp: 'pmm 10/20/2006 21:44'!
visitTimeOfDayDescription: aTimeOfDayDescription
	self visitChronosDescription: aTimeOfDayDescription! !

!MAVisitor methodsFor: '*Magritte-Chronos' stamp: 'pmm 10/20/2006 21:43'!
visitTimepointDescription: aTimepointDescription
	self visitChronosDescription: aTimepointDescription! !

!MAVisitor methodsFor: '*Magritte-Chronos' stamp: 'pmm 10/20/2006 21:44'!
visitYearMonthDayDescription: aYearMonthDayDescription
	self visitChronosDescription: aYearMonthDayDescription! !

!MAStringReader methodsFor: '*Magritte-Chronos' stamp: 'pmm 10/20/2006 22:56'!
visitChronosDescription: aChronosDescription
	"doesn't work for all Chronos descriptions :("
	"self object: (aChronosDescription kind
		readFrom: self stream
		using: aChronosDescription parser)"
	self visitMagnitudeDescription: aChronosDescription! !

!MAStringReader methodsFor: '*Magritte-Chronos' stamp: 'pmm 10/20/2006 22:55'!
visitTimeOfDayDescription: aChronosDescription
	self object: (aChronosDescription kind
		readFrom: self stream
		using: aChronosDescription parser)! !

!MAStringReader methodsFor: '*Magritte-Chronos' stamp: 'pmm 10/20/2006 22:55'!
visitTimepointDescription: aChronosDescription
	self object: (aChronosDescription kind
		readFrom: self stream
		using: aChronosDescription parser)! !

MAMagnitudeDescription subclass: #CHChronosDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Chronos-Description'!

!CHChronosDescription commentStamp: 'pmm 10/20/2006 22:42' prior: 0!
A CHChronosDescription is the superclass of all Chronos descriptions.!

!CHChronosDescription class methodsFor: 'accessing-defaults' stamp: 'pmm 10/20/2006 22:58'!
defaultParser
	^ ChronosParser iso8601! !

!CHChronosDescription class methodsFor: 'accessing-defaults' stamp: 'pmm 10/20/2006 21:51'!
defaultPrintPolicy
	^ ChronosPrintPolicy ansiStandard! !

!CHChronosDescription class methodsFor: 'accessing-description' stamp: 'pmm 10/21/2006 13:55'!
descriptionParser
	^(MASingleOptionDescription selector: #parserKey label: 'Parser' priority: 1100)
		options: self parserKeys;
		beRequired;
		yourself! !

!CHChronosDescription class methodsFor: 'accessing-description' stamp: 'pmm 10/21/2006 13:54'!
descriptionPrintPolicy
	^(MASingleOptionDescription selector: #printPolicyKey label: 'Print Policy' priority: 1000)
		options: self printPolicyKeys;
		beRequired;
		yourself! !

!CHChronosDescription class methodsFor: 'accessing' stamp: 'pmm 10/21/2006 13:34'!
parserKeys
	^#(
		ansiStandard
		default
		dmy
		iso8601
		mdy
		rfc2822
		ymd
	)! !

!CHChronosDescription class methodsFor: 'accessing' stamp: 'pmm 10/21/2006 13:32'!
printPolicyKeys
	^#(
		ansiStandard
		default
		
		dmyOnly
		germanLong
		germanShort
		
		iso8601
		isoWeekOfYearDayOfWeek
		mdyOnly
		
		rfc2822
		rfc2822v
		rfc822
		
		universal
		
		usLong
		usShort
		
		verbose
		vwTimestamp
		ymdOnly
	)! !

!CHChronosDescription methodsFor: 'visiting' stamp: 'pmm 10/20/2006 22:40'!
acceptMagritte: aVisitor
	aVisitor visitChronosDescription: self! !

!CHChronosDescription methodsFor: 'conveniance' stamp: 'pmm 10/21/2006 13:23'!
beAnsiStandard
	self printAnsiStandard.
	self parseAnsiStandard.! !

!CHChronosDescription methodsFor: 'conveniance' stamp: 'pmm 10/21/2006 13:22'!
beIso8601
	self printIso8601.
	self parseIso8601.! !

!CHChronosDescription methodsFor: 'conveniance' stamp: 'pmm 10/21/2006 13:23'!
beRfc2822
	self printRfc2822.
	self parseRfc2822.! !

!CHChronosDescription methodsFor: 'conveniance-parsing' stamp: 'pmm 10/21/2006 13:23'!
parseAnsiStandard
	self parser: ChronosParser ansiStandard! !

!CHChronosDescription methodsFor: 'conveniance-parsing' stamp: 'pmm 10/21/2006 13:34'!
parseDayMonthYear
	self parser: ChronosParser dmy! !

!CHChronosDescription methodsFor: 'conveniance-parsing' stamp: 'pmm 10/21/2006 13:34'!
parseDefault
	self parser: ChronosParser default! !

!CHChronosDescription methodsFor: 'conveniance-parsing' stamp: 'pmm 10/21/2006 13:20'!
parseIso8601
	self parser: ChronosParser iso8601! !

!CHChronosDescription methodsFor: 'conveniance-parsing' stamp: 'pmm 10/21/2006 13:34'!
parseMonthDayYear
	self parser: ChronosParser mdy! !

!CHChronosDescription methodsFor: 'conveniance-parsing' stamp: 'pmm 10/21/2006 13:20'!
parseRfc2822
	self parser: ChronosParser rfc2822! !

!CHChronosDescription methodsFor: 'conveniance-parsing' stamp: 'pmm 10/21/2006 13:33'!
parseYearMonthDay
	self parser: ChronosParser ymd! !

!CHChronosDescription methodsFor: 'accessing-configuration' stamp: 'pmm 10/21/2006 13:16'!
parser
	^ self
		propertyAt: #parser
		ifAbsentPut: [ self class defaultParser ]! !

!CHChronosDescription methodsFor: 'accessing-configuration' stamp: 'pmm 10/21/2006 13:16'!
parser: aChronosParser
	^ self
		propertyAt: #parser
		put: aChronosParser! !

!CHChronosDescription methodsFor: 'accessing-configuration' stamp: 'pmm 10/21/2006 13:26'!
parserKey
	^self parser registrationKey! !

!CHChronosDescription methodsFor: 'accessing-configuration' stamp: 'pmm 10/21/2006 13:27'!
parserKey: aSymbol
	self parser: (ChronosParser at: aSymbol)! !

!CHChronosDescription methodsFor: 'conveniance-printing' stamp: 'pmm 10/21/2006 13:23'!
printAnsiStandard
	self printPolicy: ChronosPrintPolicy ansiStandard! !

!CHChronosDescription methodsFor: 'conveniance-printing' stamp: 'pmm 10/21/2006 13:35'!
printDayMonthYearOnly
	self printPolicy: ChronosPrintPolicy dmyOnly! !

!CHChronosDescription methodsFor: 'conveniance-printing' stamp: 'pmm 10/21/2006 13:35'!
printDefault
	self printPolicy: ChronosPrintPolicy default! !

!CHChronosDescription methodsFor: 'conveniance-printing' stamp: 'pmm 10/21/2006 13:35'!
printGermanLong
	self printPolicy: ChronosPrintPolicy germanLong! !

!CHChronosDescription methodsFor: 'conveniance-printing' stamp: 'pmm 10/21/2006 13:35'!
printGermanShort
	self printPolicy: ChronosPrintPolicy germanShort! !

!CHChronosDescription methodsFor: 'conveniance-printing' stamp: 'pmm 10/21/2006 13:18'!
printIso8601
	self printPolicy: ChronosPrintPolicy iso8601! !

!CHChronosDescription methodsFor: 'conveniance-printing' stamp: 'pmm 10/21/2006 13:36'!
printIsoMonthDayYearOnly
	self printPolicy: ChronosPrintPolicy mdyOnly! !

!CHChronosDescription methodsFor: 'conveniance-printing' stamp: 'pmm 10/21/2006 13:36'!
printIsoWeekOfYearDayOfWeek
	self printPolicy: ChronosPrintPolicy isoWeekOfYearDayOfWeek! !

!CHChronosDescription methodsFor: 'accessing-configuration' stamp: 'pmm 10/21/2006 13:16'!
printPolicy
	^ self
		propertyAt: #printPolicy
		ifAbsentPut: [ self class defaultPrintPolicy ]! !

!CHChronosDescription methodsFor: 'accessing-configuration' stamp: 'pmm 10/21/2006 13:16'!
printPolicy: aChronosPrintPolicy
	^ self
		propertyAt: #printPolicy
		put: aChronosPrintPolicy! !

!CHChronosDescription methodsFor: 'accessing-configuration' stamp: 'pmm 10/21/2006 13:28'!
printPolicyKey
	^self printPolicy registrationKey! !

!CHChronosDescription methodsFor: 'accessing-configuration' stamp: 'pmm 10/21/2006 13:27'!
printPolicyKey: aSymbol
	self printPolicy: (ChronosPrintPolicy at: aSymbol)! !

!CHChronosDescription methodsFor: 'conveniance-printing' stamp: 'pmm 10/21/2006 13:21'!
printRfc2822
	self printPolicy: ChronosPrintPolicy rfc2822! !

!CHChronosDescription methodsFor: 'conveniance-printing' stamp: 'pmm 10/21/2006 13:36'!
printRfc2822Verbose
	self printPolicy: ChronosPrintPolicy rfc2822v! !

!CHChronosDescription methodsFor: 'conveniance-printing' stamp: 'pmm 10/21/2006 13:36'!
printRfc822
	self printPolicy: ChronosPrintPolicy rfc822! !

!CHChronosDescription methodsFor: 'conveniance-printing' stamp: 'pmm 10/21/2006 13:37'!
printUniversal
	self printPolicy: ChronosPrintPolicy universal! !

!CHChronosDescription methodsFor: 'conveniance-printing' stamp: 'pmm 10/21/2006 13:37'!
printUsLong
	self printPolicy: ChronosPrintPolicy usLong! !

!CHChronosDescription methodsFor: 'conveniance-printing' stamp: 'pmm 10/21/2006 13:37'!
printUsShort
	self printPolicy: ChronosPrintPolicy usShort! !

!CHChronosDescription methodsFor: 'conveniance-printing' stamp: 'pmm 10/21/2006 13:37'!
printVerbose
	self printPolicy: ChronosPrintPolicy verbose! !

!CHChronosDescription methodsFor: 'conveniance-printing' stamp: 'pmm 10/21/2006 13:37'!
printVisualWorksTimestamp
	self printPolicy: ChronosPrintPolicy vwTimestamp! !

!CHChronosDescription methodsFor: 'conveniance-printing' stamp: 'pmm 10/21/2006 13:38'!
printYearMonthDayOnly
	self printPolicy: ChronosPrintPolicy ymdOnly! !

CHChronosDescription subclass: #CHScientificDurationDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Chronos-Description'!

!CHScientificDurationDescription commentStamp: 'pmm 10/20/2006 22:42' prior: 0!
A CHScientificDurationDescription is the Chronos version of MADurationDescription.!

!CHScientificDurationDescription class methodsFor: 'accessing' stamp: 'pmm 10/22/2006 07:18'!
defaultComponentClasses
	^ Array with: MATextInputComponent! !

!CHScientificDurationDescription class methodsFor: 'testing' stamp: 'pmm 10/20/2006 21:15'!
isAbstract
	^ false! !

!CHScientificDurationDescription class methodsFor: 'accessing' stamp: 'pmm 10/20/2006 21:15'!
label
	^ MADurationDescription label! !

!CHScientificDurationDescription methodsFor: 'visiting' stamp: 'pmm 10/20/2006 21:45'!
acceptMagritte: aVisitor
	aVisitor visitScientificDurationDescription: self! !

!CHScientificDurationDescription methodsFor: 'accessing' stamp: 'pmm 10/20/2006 21:59'!
kind
	^ ScientificDuration! !

CHChronosDescription subclass: #CHTimeOfDayDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Chronos-Description'!

!CHTimeOfDayDescription commentStamp: 'pmm 10/20/2006 22:43' prior: 0!
A CHTimeOfDayDescription is the Chronos version of MATimeDescription.!

!CHTimeOfDayDescription class methodsFor: 'accessing' stamp: 'pmm 10/22/2006 08:16'!
defaultComponentClasses
	^ Array with: MATextInputComponent with: CHTimeSelectorComponent! !

!CHTimeOfDayDescription class methodsFor: 'testing' stamp: 'pmm 10/20/2006 21:17'!
isAbstract
	^ false! !

!CHTimeOfDayDescription class methodsFor: 'accessing' stamp: 'pmm 10/20/2006 21:39'!
label
	^ MATimeDescription label! !

!CHTimeOfDayDescription methodsFor: 'visiting' stamp: 'pmm 10/20/2006 21:45'!
acceptMagritte: aVisitor
	aVisitor visitTimeOfDayDescription: self! !

!CHTimeOfDayDescription methodsFor: 'accessing' stamp: 'pmm 10/20/2006 21:59'!
kind
	^ TimeOfDay! !

CHChronosDescription subclass: #CHTimepointDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Chronos-Description'!

!CHTimepointDescription commentStamp: 'pmm 10/20/2006 22:43' prior: 0!
A CHTimepointDescription is the Chronos version of MATimeStampDescription.
!

!CHTimepointDescription class methodsFor: 'accessing' stamp: 'pmm 10/22/2006 12:59'!
defaultComponentClasses
	^ Array with: MATextInputComponent with: CHTimepointSelectorComponent! !

!CHTimepointDescription class methodsFor: 'testing' stamp: 'pmm 10/20/2006 22:40'!
isAbstract
	^ false! !

!CHTimepointDescription class methodsFor: 'accessing' stamp: 'pmm 10/20/2006 22:40'!
label
	^ MATimeStampDescription label! !

!CHTimepointDescription methodsFor: 'visiting' stamp: 'pmm 10/20/2006 22:41'!
acceptMagritte: aVisitor
	aVisitor visitTimepointDescription: self! !

!CHTimepointDescription methodsFor: 'accessing' stamp: 'pmm 10/20/2006 22:40'!
kind
	^ Timepoint! !

CHChronosDescription subclass: #CHYearMonthDayDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Chronos-Description'!

!CHYearMonthDayDescription commentStamp: 'pmm 10/20/2006 22:43' prior: 0!
A CHYearMonthDayDescription is the Chronos version of MADateDescription.!

!CHYearMonthDayDescription class methodsFor: 'accessing' stamp: 'pmm 10/22/2006 08:16'!
defaultComponentClasses
	^ Array with: MATextInputComponent with: CHYearMonthDaySelectorComponent! !

!CHYearMonthDayDescription class methodsFor: 'testing' stamp: 'pmm 10/20/2006 22:41'!
isAbstract
	^ false! !

!CHYearMonthDayDescription class methodsFor: 'accessing' stamp: 'pmm 10/20/2006 22:42'!
label
	^ MADateDescription label! !

!CHYearMonthDayDescription methodsFor: 'visiting' stamp: 'pmm 10/20/2006 22:41'!
acceptMagritte: aVisitor
	aVisitor visitYearMonthDayDescription: self! !

!CHYearMonthDayDescription methodsFor: 'accessing' stamp: 'pmm 10/20/2006 22:41'!
kind
	^ YearMonthDay! !

MAElementComponent subclass: #CHTimepointSelectorComponent
	instanceVariableNames: 'selector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Chronos-Seaside'!

!CHTimepointSelectorComponent class methodsFor: 'testing' stamp: 'pmm 10/22/2006 12:53'!
isAbstract
	^false! !

!CHTimepointSelectorComponent methodsFor: 'accessing' stamp: 'pmm 10/22/2006 12:53'!
children
	^Array with: selector! !

!CHTimepointSelectorComponent methodsFor: 'initialize-release' stamp: 'pmm 10/22/2006 12:53'!
initialize
	super initialize.
	selector := self selectorClass new! !

!CHTimepointSelectorComponent methodsFor: 'testing' stamp: 'pmm 10/22/2006 12:53'!
isMultipart
	^false! !

!CHTimepointSelectorComponent methodsFor: 'actions' stamp: 'pmm 10/22/2006 12:58'!
now
	| now |
	now := self timestampClass now.
	self value: now.
	selector timepoint: now! !

!CHTimepointSelectorComponent methodsFor: 'rendering' stamp: 'pmm 10/22/2006 12:58'!
renderEditorOn: html
	html render: selector.
	html hiddenInput
		callback: [
			selector timepointIsValid ifTrue: [
				self value: selector timepoint ] ].
	html submitButton on: #now of: self! !

!CHTimepointSelectorComponent methodsFor: 'private' stamp: 'pmm 10/22/2006 12:53'!
selectorClass
	^ WADateSelector! !

!CHTimepointSelectorComponent methodsFor: 'initialize-release' stamp: 'pmm 10/22/2006 12:57'!
setDescription: aDescription
	| timepoint |
	super setDescription: aDescription.
	timepoint := self value.
	timepoint isNil ifFalse: [
		selector timepoint: timepoint ]! !

!CHTimepointSelectorComponent methodsFor: 'private' stamp: 'pmm 10/22/2006 12:55'!
timestampClass
	^Timepoint! !

!CHTimepointSelectorComponent methodsFor: 'validation' stamp: 'pmm 10/22/2006 12:58'!
validate
	super validate.
	selector timepointIsValid ifFalse: [
		MAKindError on: self description ]! !

WAComponent subclass: #CHTimepointSelector
	instanceVariableNames: 'dateSelector timeSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Chronos-Seaside'!

!CHTimepointSelector methodsFor: 'accessing' stamp: 'pmm 10/22/2006 12:47'!
children

	^ Array with: dateSelector with: timeSelector! !

!CHTimepointSelector methodsFor: 'initialize-release' stamp: 'pmm 10/22/2006 12:48'!
initialize
	super initialize.
	dateSelector := CHYearMonthDaySelector new.
	timeSelector := CHTimeOfDaySelector new.! !

!CHTimepointSelector methodsFor: 'rendering' stamp: 'pmm 10/22/2006 12:47'!
renderContentOn: html

	html span: dateSelector.
	html span: [html strong: ' : '].
	html span: timeSelector.! !

!CHTimepointSelector methodsFor: 'accessing' stamp: 'pmm 10/22/2006 12:50'!
timepoint
	| yearMonthDay timeOfDay |
	yearMonthDay := dateSelector value.
	timeOfDay := timeSelector value.
	^Timepoint
		year: yearMonthDay year
		month: yearMonthDay month
		day: yearMonthDay dayOfMonth
		hour: timeOfDay hour
		minute: timeOfDay minute
		second: timeOfDay second! !

!CHTimepointSelector methodsFor: 'accessing' stamp: 'pmm 10/22/2006 12:48'!
timepoint: aTimepoint

	dateSelector date: aTimepoint asDate.
	timeSelector time: aTimepoint timeOfDay.! !

!CHTimepointSelector methodsFor: 'testing' stamp: 'pmm 10/22/2006 12:52'!
timepointIsValid
	^dateSelector dateIsValid
		and: [ timeSelector timeIsValid ]! !

WATimeSelector subclass: #CHTimeOfDaySelector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Chronos-Seaside'!

!CHTimeOfDaySelector methodsFor: 'private' stamp: 'pmm 10/22/2006 07:24'!
timeClass
	^ TimeOfDay! !

MATimeSelectorComponent subclass: #CHTimeSelectorComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Chronos-Seaside'!

!CHTimeSelectorComponent methodsFor: 'private' stamp: 'pmm 10/22/2006 07:31'!
selectorClass
	^ CHTimeOfDaySelector! !

!CHTimeSelectorComponent methodsFor: 'private' stamp: 'pmm 10/22/2006 07:53'!
timeClass
	^ TimeOfDay! !

!MAStringWriter methodsFor: '*Magritte-Chronos' stamp: 'pmm 10/20/2006 21:55'!
visitChronosDescription: aChronosDescription
	self object
		printOn: self stream
		using: aChronosDescription printPolicy! !

WADateSelector subclass: #CHYearMonthDaySelector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Chronos-Seaside'!

!CHYearMonthDaySelector methodsFor: 'accessing' stamp: 'pmm 10/22/2006 08:07'!
date: aDate
	day := aDate dayOfMonth.
	month := aDate month.
	year := aDate year.! !

!CHYearMonthDaySelector methodsFor: 'private' stamp: 'pmm 10/22/2006 08:10'!
dateClass
	^ YearMonthDay! !

MADateSelectorComponent subclass: #CHYearMonthDaySelectorComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Chronos-Seaside'!

!CHYearMonthDaySelectorComponent methodsFor: 'private' stamp: 'pmm 10/22/2006 08:10'!
dateClass
	^ YearMonthDay! !

!CHYearMonthDaySelectorComponent methodsFor: 'private' stamp: 'pmm 10/22/2006 08:10'!
selectorClass
	^ CHYearMonthDaySelector! !

MAMagnitudeDescriptionTest subclass: #CHChronosDescriptionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Chronos-Tests'!

!CHChronosDescriptionTest methodsFor: 'testing' stamp: 'pmm 10/21/2006 14:00'!
testFromStringCollectionFormats
	self description beAnsiStandard.
	self testFromStringCollection.
	
	self description beIso8601.
	self testFromStringCollection.
	
	self description beRfc2822.
	self testFromStringCollection.! !

!CHChronosDescriptionTest methodsFor: 'testing' stamp: 'pmm 10/21/2006 14:00'!
testFromStringFormats
	self description beAnsiStandard.
	self testFromString.
	
	self description beIso8601.
	self testFromString.
	
	self description beRfc2822.
	self testFromString.! !

!CHChronosDescriptionTest methodsFor: 'testing' stamp: 'pmm 10/21/2006 14:00'!
testFromStringNullFormats
	self description beAnsiStandard.
	self testFromStringNull.
	
	self description beIso8601.
	self testFromStringNull.
	
	self description beRfc2822.
	self testFromStringNull.! !

!CHChronosDescriptionTest methodsFor: 'testing' stamp: 'pmm 10/21/2006 13:58'!
testToStringCollectionFormats
	self description beAnsiStandard.
	self testToStringCollection.
	
	self description beIso8601.
	self testToStringCollection.
	
	self description beRfc2822.
	self testToStringCollection.! !

!CHChronosDescriptionTest methodsFor: 'testing' stamp: 'pmm 10/21/2006 13:58'!
testToStringFormats
	self description beAnsiStandard.
	self testToString.
	
	self description beIso8601.
	self testToString.
	
	self description beRfc2822.
	self testToString.! !

!CHChronosDescriptionTest methodsFor: 'testing' stamp: 'pmm 10/21/2006 13:59'!
testToStringFromStringFormats
	self description beAnsiStandard.
	self testToStringFromString.
	
	self description beIso8601.
	self testToStringFromString.
	
	self description beRfc2822.
	self testToStringFromString.! !

!CHChronosDescriptionTest methodsFor: 'testing' stamp: 'pmm 10/21/2006 13:59'!
testToStringNullFormats
	self description beAnsiStandard.
	self testToStringNull.
	
	self description beIso8601.
	self testToStringNull.
	
	self description beRfc2822.
	self testToStringNull.! !

!CHChronosDescriptionTest methodsFor: 'testing' stamp: 'pmm 10/21/2006 13:59'!
testToStringUndefinedFormats
	self description beAnsiStandard.
	self testToStringUndefined.
	
	self description beIso8601.
	self testToStringUndefined.
	
	self description beRfc2822.
	self testToStringUndefined.! !

CHChronosDescriptionTest subclass: #CHScientificDurationDescriptionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Chronos-Tests'!

!CHScientificDurationDescriptionTest class methodsFor: 'testing' stamp: 'pmm 10/20/2006 22:46'!
isAbstract
	^ false! !

!CHScientificDurationDescriptionTest methodsFor: 'private' stamp: 'pmm 10/20/2006 22:05'!
actualClass
	^ CHScientificDurationDescription ! !

!CHScientificDurationDescriptionTest methodsFor: 'private' stamp: 'pmm 10/20/2006 22:05'!
includedInstance
	^ ScientificDuration days: 1 hours: 2 minutes: 3 seconds: 4! !

!CHScientificDurationDescriptionTest methodsFor: 'private' stamp: 'pmm 10/20/2006 22:05'!
maxInstance
	^ ScientificDuration days: 2 hours: 2 minutes: 3 seconds: 4! !

!CHScientificDurationDescriptionTest methodsFor: 'private' stamp: 'pmm 10/20/2006 22:05'!
minInstance
	^ ScientificDuration days: 0 hours: 2 minutes: 3 seconds: 4! !

CHChronosDescriptionTest subclass: #CHTimeOfDayDescriptionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Chronos-Tests'!

!CHTimeOfDayDescriptionTest class methodsFor: 'testing' stamp: 'pmm 10/20/2006 22:01'!
isAbstract
	^ false! !

!CHTimeOfDayDescriptionTest methodsFor: 'private' stamp: 'pmm 10/20/2006 22:05'!
actualClass
	^ CHTimeOfDayDescription! !

!CHTimeOfDayDescriptionTest methodsFor: 'private' stamp: 'pmm 10/20/2006 22:06'!
includedInstance
	^ TimeOfDay hour: 11 minute: 33 second: 12! !

!CHTimeOfDayDescriptionTest methodsFor: 'private' stamp: 'pmm 10/20/2006 22:06'!
maxInstance
	^ TimeOfDay hour: 12 minute: 33 second: 12! !

!CHTimeOfDayDescriptionTest methodsFor: 'private' stamp: 'pmm 10/20/2006 22:06'!
minInstance
	^ TimeOfDay hour: 10 minute: 33 second: 12! !

CHChronosDescriptionTest subclass: #CHTimepointDescriptionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Chronos-Tests'!

!CHTimepointDescriptionTest class methodsFor: 'testing' stamp: 'pmm 10/20/2006 22:02'!
isAbstract
	^ false! !

!CHTimepointDescriptionTest methodsFor: 'private' stamp: 'pmm 10/20/2006 22:06'!
actualClass
	^ CHTimepointDescription! !

!CHTimepointDescriptionTest methodsFor: 'private' stamp: 'pmm 10/20/2006 22:06'!
includedInstance
	^ Timepoint year: 1980 month: 6 day: 11 hour: 11 minute: 38 second: 12! !

!CHTimepointDescriptionTest methodsFor: 'private' stamp: 'pmm 10/20/2006 22:06'!
maxInstance
	^ Timepoint year: 1980 month: 6 day: 12 hour: 11 minute: 38 second: 12! !

!CHTimepointDescriptionTest methodsFor: 'private' stamp: 'pmm 10/20/2006 22:06'!
minInstance
	^ Timepoint year: 1980 month: 6 day: 10 hour: 11 minute: 38 second: 12! !

CHChronosDescriptionTest subclass: #CHYearMonthDayDescriptionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Chronos-Tests'!

!CHYearMonthDayDescriptionTest class methodsFor: 'testing' stamp: 'pmm 10/20/2006 22:46'!
isAbstract
	^ false! !

!CHYearMonthDayDescriptionTest methodsFor: 'private' stamp: 'pmm 10/20/2006 22:07'!
actualClass
	^ CHYearMonthDayDescription! !

!CHYearMonthDayDescriptionTest methodsFor: 'private' stamp: 'pmm 10/20/2006 22:07'!
includedInstance
	^ YearMonthDay year: 1980 month: 6  day: 11! !

!CHYearMonthDayDescriptionTest methodsFor: 'private' stamp: 'pmm 10/20/2006 22:07'!
maxInstance
	^ YearMonthDay year: 1980 month: 6 day: 12! !

!CHYearMonthDayDescriptionTest methodsFor: 'private' stamp: 'pmm 10/20/2006 22:37'!
minInstance
	^ YearMonthDay year: 1980 month: 6 day: 10! !
